#ifndef EFL_GENERATED_ELM_INTERFACE_ATSPI_TEXT_HH
#define EFL_GENERATED_ELM_INTERFACE_ATSPI_TEXT_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_atspi_text.eo.h"
}

#include <string>

struct elm_interface_atspi_text;

/// @cond EO_CXX_ABSTRACT
namespace eo_cxx {

struct elm_interface_atspi_text
{
#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   /// @param start_offset 
   /// @param end_offset 
   ///
   bool selection_add(int start_offset_, int end_offset_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   /// @param selection_number 
   ///
   bool selection_remove(int selection_number_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   Eina_Unicode character_get(int offset_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   char * string_get(Elm_Atspi_Text_Granularity granularity_, int * start_offset_, int * end_offset_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   char * text_get(int start_offset_, int end_offset_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   int caret_offset_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   bool caret_offset_set(int offset_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   bool attribute_get(::efl::eina::string_view name_, int * start_offset_, int * end_offset_, char ** value_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   ::efl::eina::list< Elm_Atspi_Text_Attribute * > attributes_get(int * start_offset_, int * end_offset_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   ::efl::eina::list< Elm_Atspi_Text_Attribute * > default_attributes_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   bool character_extents_get(int offset_, bool screen_coords_, Eina_Rectangle* rect_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   int character_count_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   int offset_at_point_get(bool screen_coords_, int x_, int y_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   ::efl::eina::list< Elm_Atspi_Text_Range * > bounded_ranges_get(bool screen_coords_, Eina_Rectangle rect_, Elm_Atspi_Text_Clip_Type xclip_, Elm_Atspi_Text_Clip_Type yclip_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   bool range_extents_get(bool screen_coords_, int start_offset_, int end_offset_, Eina_Rectangle* rect_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   int selections_count_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   void selection_get(int selection_number_, int* start_offset_, int* end_offset_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   bool selection_set(int selection_number_, int start_offset_, int end_offset_) const;
#endif

   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_bounds_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_BOUNDS_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_BOUNDS_CHANGED );
   }

   template <typename T>
   void
   callback_access_text_bounds_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_BOUNDS_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_attributes_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_ATTRIBUTES_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_ATTRIBUTES_CHANGED );
   }

   template <typename T>
   void
   callback_access_text_attributes_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_ATTRIBUTES_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_caret_moved_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_CARET_MOVED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_CARET_MOVED );
   }

   template <typename T>
   void
   callback_access_text_caret_moved_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_CARET_MOVED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_inserted_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_INSERTED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_INSERTED );
   }

   template <typename T>
   void
   callback_access_text_inserted_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_INSERTED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_removed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_REMOVED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_REMOVED );
   }

   template <typename T>
   void
   callback_access_text_removed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_REMOVED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_selection_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_SELECTION_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_SELECTION_CHANGED );
   }

   template <typename T>
   void
   callback_access_text_selection_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_SELECTION_CHANGED, info));
   }



   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_TEXT_INTERFACE);
   }

   operator ::elm_interface_atspi_text() const;
   operator ::elm_interface_atspi_text&();
   operator ::elm_interface_atspi_text const&() const;

   /// @cond LOCAL
   template <typename D>
   struct address_of
   {
      operator ::elm_interface_atspi_text*() const { return static_cast<::elm_interface_atspi_text*>(static_cast<D const*>(this)->p); }
      operator ::elm_interface_atspi_text const*() const { return static_cast<::elm_interface_atspi_text const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::elm_interface_atspi_text const*() const { return static_cast<::elm_interface_atspi_text const*>(static_cast<D const*>(this)->p); }
   };
   /// @endcond

private:

   /// @internal
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}
/// @endcond

/// @brief Class elm_interface_atspi_text
struct elm_interface_atspi_text
      : ::efl::eo::concrete
{
   //@{
   /**
      @brief Constructs a new elm_interface_atspi_text object.

      Constructs a new elm_interface_atspi_text object. If you want this object to be a child
      of another Eo object, use an @ref efl::eo::parent expression, like the example.

      Example:
      @code
      elm_interface_atspi_text my_elm_interface_atspi_text(efl::eo::parent = parent_object);
      @endcode

      @see elm_interface_atspi_text(Eo* eo)
   */
   explicit elm_interface_atspi_text(::efl::eo::parent_type _p)
      : elm_interface_atspi_text(_ctors_call(_p))
   {}

   explicit elm_interface_atspi_text()
      : elm_interface_atspi_text(_ctors_call(::efl::eo::parent = nullptr))
   {}
   //@}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_atspi_text(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_atspi_text(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_atspi_text(elm_interface_atspi_text const& other)
      : elm_interface_atspi_text(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_atspi_text() {}

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   /// @param start_offset 
   /// @param end_offset 
   ///
   bool selection_add(int start_offset_, int end_offset_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   /// @param selection_number 
   ///
   bool selection_remove(int selection_number_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   Eina_Unicode character_get(int offset_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   char * string_get(Elm_Atspi_Text_Granularity granularity_, int * start_offset_, int * end_offset_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   char * text_get(int start_offset_, int end_offset_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   int caret_offset_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   bool caret_offset_set(int offset_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   bool attribute_get(::efl::eina::string_view name_, int * start_offset_, int * end_offset_, char ** value_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   ::efl::eina::list< Elm_Atspi_Text_Attribute * > attributes_get(int * start_offset_, int * end_offset_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   ::efl::eina::list< Elm_Atspi_Text_Attribute * > default_attributes_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   bool character_extents_get(int offset_, bool screen_coords_, Eina_Rectangle* rect_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   int character_count_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   int offset_at_point_get(bool screen_coords_, int x_, int y_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   ::efl::eina::list< Elm_Atspi_Text_Range * > bounded_ranges_get(bool screen_coords_, Eina_Rectangle rect_, Elm_Atspi_Text_Clip_Type xclip_, Elm_Atspi_Text_Clip_Type yclip_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   bool range_extents_get(bool screen_coords_, int start_offset_, int end_offset_, Eina_Rectangle* rect_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   int selections_count_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   void selection_get(int selection_number_, int* start_offset_, int* end_offset_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_TEXT_PROTECTED
   bool selection_set(int selection_number_, int start_offset_, int end_offset_) const;
#endif

   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_attributes_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_ATTRIBUTES_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_ATTRIBUTES_CHANGED );
   }

   template <typename T>
   void
   callback_access_text_attributes_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_ATTRIBUTES_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_bounds_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_BOUNDS_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_BOUNDS_CHANGED );
   }

   template <typename T>
   void
   callback_access_text_bounds_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_BOUNDS_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_caret_moved_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_CARET_MOVED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_CARET_MOVED );
   }

   template <typename T>
   void
   callback_access_text_caret_moved_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_CARET_MOVED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_inserted_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_INSERTED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_INSERTED );
   }

   template <typename T>
   void
   callback_access_text_inserted_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_INSERTED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_removed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_REMOVED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_REMOVED );
   }

   template <typename T>
   void
   callback_access_text_removed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_REMOVED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_selection_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_SELECTION_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_SELECTION_CHANGED );
   }

   template <typename T>
   void
   callback_access_text_selection_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_SELECTION_CHANGED, info));
   }



   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_TEXT_INTERFACE);
   }

   /// @cond LOCAL
   struct address_of
      : ::eo_cxx::elm_interface_atspi_text::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::elm_interface_atspi_text* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::elm_interface_atspi_text::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::elm_interface_atspi_text const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

   /// @endcond

private:

   /// @internal
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(ELM_INTERFACE_ATSPI_TEXT_INTERFACE, _p._eo_raw);

      return _ret_eo;
   }

   /// @internal
   Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::elm_interface_atspi_text) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::elm_interface_atspi_text>::value, "");


#include "elm_interface_atspi_text.eo.impl.hh"

#endif // EFL_GENERATED_ELM_INTERFACE_ATSPI_TEXT_HH

